Bug 456276 - Review Request: freemarker - FreeMarker template engine
Review Request: freemarker - FreeMarker template engine
Status: CLOSED NEXTRELEASE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
low Severity medium
: ---
: ---
Assigned To: Lillian Angel
Fedora Extras Quality Assurance
:
Depends On:
Blocks: 456337
  Show dependency treegraph
 
Reported: 2008-07-22 12:03 EDT by Victor G. Vasilyev
Modified: 2008-09-03 19:36 EDT (History)
5 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2008-09-03 18:41:54 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
langel: fedora‑review+
kevin: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Victor G. Vasilyev 2008-07-22 12:03:34 EDT
Spec URL: http://nbi.netbeans.org/files/documents/210/2044/freemarker.spec
SRPM URL: http://nbi.netbeans.org/files/documents/210/2045/freemarker-2.3.13-1.fc10.src.rpm
Description: 
FreeMarker is a Java tool to generate text output based on templates.
It is designed to be practical as a template engine to generate web
pages and particularly for servlet-based page production that follows
the MVC (Model View Controller) pattern. That is, you can separate the
work of Java programmers and website designers - Java programmers
needn't know how to design nice websites, and website designers needn't
know Java programming.

This package is required for the NetBeans IDE 6.1
Comment 1 Victor G. Vasilyev 2008-07-31 13:11:21 EDT
This is my first contribution so I need a sponsor please.
Comment 2 Victor G. Vasilyev 2008-08-14 14:33:58 EDT
The second release is prepared for review.
Spec URL: http://nbi.netbeans.org/files/documents/210/2044/freemarker.spec
SRPM URL: http://nbi.netbeans.org/files/documents/210/2110/freemarker-2.3.13-2.fc10.src.rpm

Changes:
- Appropriate values of Group Tags are chosen from the official list
- Versions of java-devel & jpackage-utils are corrected
- Name of dir for javadoc is changed
- Manual is removed due to http://freemarker.org/docs/index.html

rpmlint shows no errors and no warnings against both SRPM and RPMs.
Comment 3 Terje Røsten 2008-08-19 15:44:41 EDT
o Source0 is almost correct, just change from prdownloads to downloads:

  Source0:        http://downloads.sourceforge.net/%{name}/%{name}-{version}.tar.gz

  Ref: https://fedoraproject.org/wiki/Packaging/SourceURL#Sourceforge.net

o Your are using % style macros for everything, that's good, however then you should replace install with %{__install} too.

o I would prefer %defattr in this form:

  %defattr(-, root, root, -)
Comment 4 Victor G. Vasilyev 2008-08-20 09:41:18 EDT
The third release is prepared for review.
Spec URL: http://nbi.netbeans.org/files/documents/210/2044/freemarker.spec
SRPM URL: http://nbi.netbeans.org/files/documents/210/2134/freemarker-2.3.13-3.fc10.src.rpm

Changes:
- The downloads.sourceforge.net host is used in the source URL
- %%{__install} and %%{__cp} are used everywhere
- %%defattr(-,root,root,-) is used everywhere
Comment 5 Lillian Angel 2008-08-27 14:00:22 EDT
The review for this will have to wait until xerces-j2 2.8 is in Fedora.
Comment 6 Victor G. Vasilyev 2008-09-01 10:59:57 EDT
(In reply to comment #5)
> The review for this will have to wait until xerces-j2 2.8 is in Fedora.

After deep investigation of the build procedure of the project I can say that the build-time dependency upon xerces-j2 package is redundant at all. The xerces.jar is only(!) used for building javadoc, but the  original source upstream is already contains pre-built javadoc files that are used to create the fremarker-javadoc subpackage. Therefore, the dependency upon xerces-j2 package can be removed without any risks.

The next release is prepared for review.
Spec URL: http://nbi.netbeans.org/files/documents/210/2044/freemarker.spec
SRPM URL: http://nbi.netbeans.org/files/documents/210/2159/freemarker-2.3.13-4.fc10.src.rpm

Changes:
- Redundant dependency upon xerces-j2 is removed (#456276#c6)
- The dos2unix package is added as the build requirements
- The ant-nodeps build-time requirement is added

The rpmlint shows no errors and no warnings against both SRPM and RPMs.

Successful koji build: http://koji.fedoraproject.org/koji/taskinfo?taskID=798011
Comment 7 Lillian Angel 2008-09-02 12:55:29 EDT
APPROVED


http://fedoraproject.org/wiki/Packaging/Guidelines

* 1 Packaging Guidelines
ok
+ 1.2.1 Licensing
ok
+ 1.3.1 Exceptions
ok
o 1.7 Use rpmlint
$ rpmlint /notnfs/langel/rpm/RPMS/noarch/freemarker-*
2 packages and 0 specfiles checked; 0 errors, 0 warnings.
o 1.8 Changelogs
ok
o 1.9 Tags
ok
o 1.10 BuildRoot tag
ok
o 1.11 Requires
ok
o 1.12 BuildRequires
ok
o 1.13 Summary and description
ok
o 1.14 Encoding
ok
o 1.15 Documentation
ok
o 1.16 Compiler flags
n/a
o 1.17 Debuginfo packages
n/a
o 1.18 Exclusion of Static Libraries
n/a
o 1.19 Duplication of system libraries
n/a
o 1.20 Beware of Rpath
n/a
o 1.21 Configuration files
n/a
o 1.22 Initscripts
n/a
o 1.23 Desktop files
n/a
o 1.24 Macros
ok
o 1.25 Handling Locale Files
n/a
o 1.26 Timestamps
n/a
o 1.27 Parallel make
n/a
o 1.28 Scriptlets requirements
n/a
o 1.29 Running scriptlets only in certain situations
n/a
o 1.30 Scriplets are only allowed to write in certain directories
n/a
o 1.31 Conditional dependencies
n/a
o 1.32 Build packages with separate user accounts
n/a
o 1.33 Relocatable packages
n/a
o 1.34 Code Vs Content
ok
o 1.35 File and Directory Ownership
ok
o 1.36 Users and Groups
ok
o 1.37 Web Applications
n/a
o 1.38 Conflicts
n/a
o 1.39 No External Kernel Modules
n/a
o 1.40 No Files or Directories under /srv
n/a
o 1.41 Application Specific Guidelines
n/a


http://fedoraproject.org/wiki/Packaging/ReviewGuidelines

MUST Items:

- MUST: rpmlint must be run on every package. The output should be posted in the review.
done. no errors
- MUST: The package must be named according to the Package Naming Guidelines .
ok
- MUST: The spec file name must match the base package %{name}, in the format %{name}.spec unless your package has an exemption on Package Naming Guidelines .
ok
- MUST: The package must meet the Packaging Guidelines .
ok
- MUST: The package must be licensed with a Fedora approved license and meet the Licensing Guidelines .
ok
- MUST: The License field in the package spec file must match the actual license.
ok
- MUST: If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc.
ok
- MUST: The spec file must be written in American English.
ok
- MUST: The spec file for the package MUST be legible. If the reviewer is unable to read the spec file, it will be impossible to perform a review. Fedora is not the place for entries into the Obfuscated Code Contest (http://www.ioccc.org/).
ok
- MUST: The sources used to build the package must match the upstream source, as provided in the spec URL. Reviewers should use md5sum for this task. If no upstream URL can be specified for this package, please see the Source URL Guidelines for how to deal with this.
- MUST: The package must successfully compile and build into binary rpms on at least one supported architecture.
ok
- MUST: If the package does not successfully compile, build or work on an architecture, then those architectures should be listed in the spec in ExcludeArch.
ok
- MUST: All build dependencies must be listed in BuildRequires, except for any that are listed in the exceptions section of the Packaging Guidelines ; inclusion of those as BuildRequires is optional. Apply common sense.
ok
- MUST: The spec file MUST handle locales properly. This is done by using the %find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.
ok
- MUST: Every binary RPM package which stores shared library files (not just symlinks) in any of the dynamic linker's default paths, must call ldconfig in %post and %postun. If the package has multiple subpackages with libraries, each subpackage should also have a %post/%postun section that calls /sbin/ldconfig.
ok
- MUST: A package must not contain any duplicate files in the %files listing.
ok
- MUST: Permissions on files must be set properly. Executables should be set with executable permissions, for example. Every %files section must include a %defattr(...) line.
ok
- MUST: Each package must have a %clean section, which contains rm -rf %{buildroot} ( or $RPM_BUILD_ROOT ).
ok
- MUST: Each package must consistently use macros, as described in the macros section of Packaging Guidelines .
ok
- MUST: The package must contain code, or permissable content. This is described in detail in the code vs. content section of Packaging Guidelines .
ok
- MUST: Large documentation files should go in a -doc subpackage. (The definition of large is left up to the packager's best judgement, but is not restricted to size. Large can refer to either size or quantity)
- MUST: If a package includes something as %doc, it must not affect the runtime of the application. To summarize: If it is in %doc, the program must run properly if it is not present.
ok
- MUST: Header files must be in a -devel package.
n/a
- MUST: Static libraries must be in a -static package.
n/a
- MUST: Packages containing pkgconfig(.pc) files must 'Requires: pkgconfig' (for directory ownership and usability).
n/a
- MUST: If a package contains library files with a suffix (e.g. libfoo.so.1.1), then library files that end in .so (without suffix) must go in a -devel package.
n/a
- MUST: In the vast majority of cases, devel packages must require the base package using a fully versioned dependency: Requires: %{name} = %{version}-%{release}
n/a
- MUST: Packages must NOT contain any .la libtool archives, these should be removed in the spec.
n/a
- MUST: Packages containing GUI applications must include a %{name}.desktop file, and that file must be properly installed with desktop-file-install in the %install section. 
n/a
- MUST: At the beginning of %install, each package MUST run rm -rf %{buildroot} ( or $RPM_BUILD_ROOT ). See Prepping BuildRoot For %install for details.
ok
- MUST: All filenames in rpm packages must be valid UTF-8.
ok


SHOULD Items:

- SHOULD: If the source package does not include license text(s) as a separate file from upstream, the packager SHOULD query upstream to include it.
ok
- SHOULD: The description and summary sections in the package spec file should contain translations for supported Non-English languages, if available.
ok
- SHOULD: The reviewer should test that the package builds in mock. See MockTricks for details on how to do this.
ok
- SHOULD: The package should compile and build into binary rpms on all supported architectures.
ok
- SHOULD: The reviewer should test that the package functions as described. A package should not segfault instead of running, for example.
ok
- SHOULD: If scriptlets are used, those scriptlets must be sane. This is vague, and left up to the reviewers judgement to determine sanity.
- SHOULD: Usually, subpackages other than devel should require the base package using a fully versioned dependency.
n/a
- SHOULD: The placement of pkgconfig(.pc) files depends on their usecase, and this is usually for development purposes, so should be placed in a -devel pkg. A reasonable exception is that the main pkg itself is a devel tool not installed in a user runtime, e.g. gcc or gdb.
n/a
- SHOULD: If the package has file dependencies outside of /etc, /bin, /sbin, /usr/bin, or /usr/sbin consider requiring the package which provides the file instead of the file itself. Please see File Dependencies in the Guidelines for further information. 
ok
Comment 8 Victor G. Vasilyev 2008-09-02 14:02:01 EDT
New Package CVS Request
=======================
Package Name: freemarker
Short Description: FreeMarker template engine
Owners: victorv
Branches:
InitialCC:
Comment 9 Kevin Fenzi 2008-09-03 16:25:02 EDT
cvs done.
Comment 10 Victor G. Vasilyev 2008-09-03 18:41:54 EDT
Successful koji build: http://koji.fedoraproject.org/koji/taskinfo?taskID=803443

Note You need to log in before you can comment on or make changes to this bug.